.globl	GetProcessHeap
.globl	GetVersionExA
.globl	HeapCreate
.globl	HeapFree
.globl	HeapAlloc
.globl	GetProcAddress
.globl	GetModuleHandleA
.globl	HeapSetInformation
.globl	FlsAlloc
.globl	FlsGetValue
.globl	FlsSetValue
.globl	EnterCriticalSection
.globl	LeaveCriticalSection
.globl	InitializeCriticalSection
.globl	GetStartupInfoA
.globl  GetSystemTimeAsFileTime
.globl  GetCurrentProcessId
.globl  GetCurrentThreadId
.globl  GetTickCount
.globl  QueryPerformanceCounter
.globl  GetStdHandle
.globl  GetFileType
.globl  SetHandleCount
.globl  GetCommandLineA
.globl  GetEnvironmentStringsW
.globl  WideCharToMultiByte
.globl  FreeEnvironmentStringsW
.globl  GetEnvironmentStrings
.globl  FreeEnvironmentStringsA
.globl  GetLastError
.globl  SetLastError
.globl  GetACP
.globl  GetCPInfo
.globl  GetModuleFileNameA
.globl  SetUnhandledExceptionFilter
.globl  HeapSize
.globl  CreateFileA
.globl  ReadFile
.globl  GetSystemInfo
.globl  CreateFileMappingA
.globl  OpenFileMappingA
.globl  MapViewOfFile
.globl  UnmapViewOfFile
.globl  CreatePipe
.globl  GetCurrentProcess
.globl  DuplicateHandle
.globl  CloseHandle
.globl  CreateProcessA
.globl  Sleep
.globl  GetConsoleMode
.globl  SetConsoleMode
.globl  FlushConsoleInputBuffer
.globl  WriteFile
.globl  GetNumberOfConsoleInputEvents
.globl  SetPriorityClass
.globl  GetLogicalDrives
.globl  SetFilePointer
.globl  FlushFileBuffers

.globl  fib_value
.globl  cmdline
.globl  num_cpus

newline: .string "\n"
icsacs: .string "InitializeCriticalSectionAndSpinCount"
appname: .string "\\\\?\\c:\\rybka\\Rybkav2.3.2a.mp.x64.exe"
env: .string "TEST=foo\000\000"

.section .bss

fib_value: .quad 0x0
last_err:	.quad 0x0
tmp:       .quad 0x0, 0x0, 0x0
num_cpus:	.quad 0x0
cmdline:	.fill 512

.section .data

pollfd: .string "\000\000\000\000\001\000\000\000"

.section .text

GetProcessHeap:
	mov       $0xf00dbad, %eax 
	retq	

GetVersionExA:
	# stub
	mov       $5, %eax
	mov       %eax, 0x4(%rcx)    # dwMajorVersion = 5 (Windows XP, et al)

	mov       $1, %eax
	mov       %eax, 0x8(%rcx)    # dwMinorVersion = 1 (Windows XP)

	mov       $31337, %eax
	mov       %eax, 0xc(%rcx)    # dwBuildNumber = 31337
	
	mov       $2, %eax
	mov       %eax, 0x10(%rcx)   # dwPlatformId = VER_PLATFORM_WIN32_NT

	mov       $0x1, %eax
	retq

# HANDLE WINAPI HeapCreate(DWORD flOptions, SIZE_T dwInitialSize, SIZE_T dwMaximumSize);
HeapCreate:
	mov       $0xf00df00d, %eax
	retq

# LPVOID WINAPI HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes);
HeapAlloc:
	# rcx = hHeap, rdx = dwFlags, r8 = dwBytes
	push      %rdx
	push      %rdi
	push      %rsi

	mov       %r8, %rdi
	call      malloc

	pop       %rsi
	pop       %rdi
	pop       %rdx
	retq

# BOOL WINAPI HeapFree(HANDLE hHeap, DWORD dwFlags, LPVOID lpMem);
HeapFree:
	# rcx = hHeap, rdx = dwFlags, r8 = lpMem
	push      %rdx
	push      %rdi
	push      %rsi

	mov       %r8, %rdi
	call      free

	pop       %rsi
	pop       %rdi
	pop       %rdx
	mov	  $0x1, %eax
	retq

GetProcAddress:
	push      %rdi
	push      %rsi
	push      %rdx

	# see if it's the evil spinlock function
	mov       %rdx, %rdi
	lea       icsacs, %rsi
	call      strcmp
	test      %eax, %eax
	jnz       .noticsacs

	# yes, it is
	lea       InitializeCriticalSectionAndSpinCount, %eax
	jmp	  .epilogue

.noticsacs:
	# find the length of the argument
	#  mov       %rdx, %rdi         #buf
	#  call      strlen

	#  # output it
	#  mov       %rax, %rdx         # count
	#  mov       %rdi, %rsi         # buf
	#  mov       $0x1, %eax         # write syscall
	#  mov       $0x1, %rdi         # fd
	#  syscall

	#  # and attach a newline
	#  mov       $0x1, %eax         # write syscall
	#  mov       $0x1, %rdi         # fd
	#  lea       newline, %rsi      # buf
	#  mov       $0x1, %rdx         # count
	#  syscall


	# let's hope it's EncodePointer/DecodePointer
	#mov       $0xdeadbeef, %rax
	lea	  EncodePointer, %rax
	
.epilogue:
	pop	  %rdx
	pop	  %rsi
	pop	  %rdi

	retq	

EncodePointer:
	mov       %rcx, %rax
	ret

GetModuleHandleA:
	# used to load mscoree.dll, it seems
	mov       $0xbadf00d, %eax
	retq

HeapSetInformation:
	mov       $0x1, %eax
	retq

FlsGetValue:
	#mov	  $0xc0ffee, %rax
	mov       fib_value, %rax
	retq

FlsSetValue:
	#mov	  $0xc0ffee, %rax
	mov       %rdx, fib_value
	retq

FlsAlloc:
	mov       $0xf1baf1ba, %rax
	retq

EnterCriticalSection:
	# stub
	retq

LeaveCriticalSection:
	# stub
	retq

InitializeCriticalSectionAndSpinCount:
	mov	$0xc7171c41, %rax
	mov	%rax, (%rcx)
	mov	$0x555c7171c41, %rax
	mov	%rax, 24(%rcx)
	mov     $0x1, %rax
	retq

InitializeCriticalSection:
	mov     $0x1, %rax
	retq

GetStartupInfoA:
	mov     $0x1, %rax
	retq

GetSystemTimeAsFileTime:
	# stub
	retq

GetCurrentProcessId:
	push    %rdx
	push    %rdi
	push    %rsi

	call    getpid

	pop     %rsi
	pop     %rdi
	pop     %rdx
	retq

GetCurrentThreadId:
	push    %rdx
	push    %rdi
	push    %rsi

	call    getpid

	pop     %rsi
	pop     %rdi
	pop     %rdx
	retq

GetTickCount:
	push    %rdx
	push    %rdi
	push    %rsi

	lea     tmp, %rdi
	xor     %rsi, %rsi
	call    gettimeofday
	
	# multiply tv_sec by a million and add tv_usec plus roundoff
	imul    $1000000, tmp, %rax
	add     tmp+8, %rax
	add     $500, %rax

	# now divide the whole thing by 1000 to get milliseconds
	xor     %rdx, %rdx
	mov     $1000, %rdi
	idiv    %rdi

	pop     %rsi
	pop     %rdi
	pop     %rdx
	retq

QueryPerformanceCounter:
	# stub
	mov    $0x87654321, %rax
	mov    %rax, (%rcx)
	mov    $1, %rax
	retq

GetStdHandle:
	mov    $0xc0501e, %rax
	retq

GetFileType:
	mov    $0x2, %rax           # FILE_TYPE_CHAR
	retq

SetHandleCount:
	# stub
	retq

GetCommandLineA:
	lea    cmdline, %rax
	retq

GetEnvironmentStringsW:
	mov    $120, %rax           # ERROR_CALL_NOT_IMPLEMENTED
        mov    %rax, last_err
	xor    %rax, %rax
	retq

WideCharToMultiByte:
	# stub
	mov    $10, %rax
	retq

FreeEnvironmentStringsW:
	# stub
	mov    $0x1, %rax
	retq

GetEnvironmentStrings:
	lea    env, %rax
	retq

FreeEnvironmentStringsA:
	# stub
	mov    $0x1, %rax
	retq

GetLastError:
	mov    last_err, %rax
	retq

SetLastError:
	mov    %rax, last_err
	retq

GetACP:
	mov    $0x08650865, %rax
	retq

GetCPInfo:
	# stub
	xor    %rax, %rax
	retq

GetModuleFileNameA:
	# stub
	push   %rdi
	push   %rsi
	push   %rdx
	
	lea    appname, %rsi
	mov    %rdx, %rdi
	call   strcpy

	lea    appname, %rdi
	call   strlen

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

SetUnhandledExceptionFilter:
	# stub
	xor    %rax, %rax
	retq

HeapSize:
	# stub
	mov    $0x100, %rax
	retq

CreateFileA:
	push   %rdi
	push   %rsi
	push   %rdx

	# change all backslashes to forward-slashes
	mov    %rcx, %rdi
.loop:
	mov    (%rcx), %al
	cmp    $0x5c, %al    # backslash
	jne    .nobackslash
	mov    $0x2f, %al    # forward-slash
	mov    %al, (%rcx)  
.nobackslash:
	inc    %rcx
	test   %al, %al
	jnz    .loop

	mov    $0x2, %rsi     # O_RDWR
	mov    $0644, %rdx
	call   open

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

ReadFile:
	push   %rdi
	push   %rsi
	push   %rdx

	# the console?
	xor    %rax, %rax
	cmp    $0xc0501e, %rcx
	cmove  %rax, %rcx

	mov    %rcx, %rdi    # fd
	mov    %rdx, %rsi    # buf
	mov    %r8, %rdx     # count
	call   read

	mov    %rax, (%r9)   # return value

	pop    %rdx
	pop    %rsi
	pop    %rdi

	mov    $0x1, %rax
	retq

WriteFile:
	push   %rdi
	push   %rsi
	push   %rdx

	# the console?
	mov    $0x1, %rax
	cmp    $0xc0501e, %rcx
	cmove  %rax, %rcx

	mov    %rcx, %rdi    # fd
	mov    %rdx, %rsi    # buf
	mov    %r8, %rdx     # count
	call   write

	mov    %rax, (%r9)   # return value

	pop    %rdx
	pop    %rsi
	pop    %rdi

	mov    $0x1, %rax
	retq

GetSystemInfo:
	mov    $9, %ax          # PROCESSOR_ARCHITECTURE_AMD64
	mov    %eax, (%rcx)

	mov    $4096, %eax      # page size
	mov    %eax, 4(%rcx)

	# 8(%rcx): lpMinimumApplicationAddress
	# 16(%rcx): lpMaximumApplicationAddress

	mov    $1, %rax         # processor bit mask
	mov    %rax, 24(%rcx)

	mov    num_cpus, %eax   # one processor for now
	mov    %eax, 32(%rcx)

	mov    $8664, %eax      # amd64
	mov    %eax, 36(%rcx)

	retq

CreateFileMappingA:
	# create a new shm segment with hash(name) as the key and the given size
	push   %rdi
	push   %rsi
	push   %rdx
	push   %r8

	mov    0x50(%rsp), %rdi      # lpName
	call   hash_str
	mov    %rax, %r8

	# try with hugetlb first, if the allocation is a multiple of 2MB
	mov    0x48(%rsp), %rsi      # size
	test   $0x1fffff, %rsi
	jnz    .nohugetlb

	mov    %rax, %rdi            # hash(lpName)
	mov    $05600, %rdx          # SHM_HUGETLB | IPC_CREAT | 0600
	call   shmget
	cmp    $-1, %rax
	jne    .success

.nohugetlb:

	mov    %r8, %rdi             # hash(lpName)
	mov    0x48(%rsp), %rsi      # size
	mov    $01600, %rdx          # IPC_CREAT | 0600
	call   shmget

.success:

	pop    %r8
	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

OpenFileMappingA:
	# largely the same as CreateFileMappingA, only without IPC_CREAT
	push   %rdi
	push   %rsi
	push   %rdx

	mov    %r8, %rdi             # lpName
	call   hash_str

	mov    %rax, %rdi            # hash(lpName)
	xor    %rsi, %rsi            # size
	mov    $0600, %rdx           # 0600 (no IPC_CREAT)
	call   shmget

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

MapViewOfFile:
	push   %rdi
	push   %rsi
	push   %rdx

	# attach to the shm segment
	mov    %rax, %rdi            # shmid
	xor    %rsi, %rsi            # don't care about the address
	xor    %rdx, %rdx            # read/write
	call   shmat

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

UnmapViewOfFile:
	# stubstubstub
	push   %rdi
	push   %rsi
	push   %rdx

	mov    %rcx, %rdi
	call   shmdt

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

CreatePipe:
	push   %rdi
	push   %rsi

	lea    tmp, %rdi
	push   %rcx
	push   %rdx
	call   pipe
	pop    %rdx
	pop    %rcx

	mov    tmp, %eax
	mov    %rax, (%rcx)       # read handle

	mov    tmp+4, %eax
	mov    %rax, (%rdx)       # write handle

	mov    $1, %rax
	
	pop    %rsi
	pop    %rdi
	retq

GetCurrentProcess:
	mov    $-1, %rax
	retq

DuplicateHandle:
	push   %rdi
	push   %rsi
	push   %rdx

	mov    %rdx, %rdi

	push   %r9
	call   dup
	pop    %r9
	mov    %rax, (%r9)
	mov    $0x1, %rax
	
	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

CloseHandle:
	push   %rdi
	push   %rsi
	push   %rdx

	# don't close stdin, no idea why this happens :-)
	test   %rcx, %rcx
	jz     .noclose

	# and if it's over 100, assume it's a shared segment
	cmp    $100, %rcx
	ja     .shmdestroy

	mov    %rcx, %rdi
	call   close
	jmp    .noclose
	
.shmdestroy:	
	# destroy the shared segment
	mov    %rcx, %rdi            # shmid
	xor    %rsi, %rsi            # IPC_RMID
	xor    %rdx, %rdx            # don't need the shmid_ds data
	call   shmctl

.noclose:
	mov    $0x1, %rax

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

CreateProcessA:
	# complex enough to make a C thunk worthwhile	
	push   %rdi
	push   %rsi
	push   %rdx

	mov    %rdx, %rdi
	mov    0x60(%rsp), %rsi
	mov    0x68(%rsp), %rdx
	call   CreateProcessA_cthunk

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

Sleep:
	push   %rdi
	push   %rsi
	push   %rdx

	imul   $1000, %rcx, %rdi
	call   usleep

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

GetConsoleMode:
	mov    $0x3, %rax     # ENABLE_PROCESSED_OUTPUT | ENABLE_WRAP_AT_EOL_OUTPUT (?)
	mov    %rax, (%rdx)
	mov    $0x1, %rax
	retq

SetConsoleMode:
	# stub
	retq

FlushConsoleInputBuffer:
	# stub
	retq

GetNumberOfConsoleInputEvents:
	push   %rdi
	push   %rsi
	push   %rdx

	lea    pollfd, %rdi 
	mov    $0x1, %rsi
	xor    %rdx, %rdx
	call   poll
	
	pop    %rdx

        xor    %rax, %rax
	mov    pollfd+6, %ax
	add    %rax, %rax         # rybka needs at least two to react
	mov    %eax, (%rdx)
	
	mov    $0x1, %rax

	pop    %rsi
	pop    %rdi
	retq

# standard djb hash
hash_str:
	push   %rdi
	push   %rcx
	xor    %rax, %rax
	xor    %rcx, %rcx

.hashloop:
	imul   $33, %rax, %rax
	movb   (%rdi), %cl
	add    %rcx, %rax
	add    $1, %rdi
	test   %rcx, %rcx
	jnz    .hashloop
	
	pop    %rcx
	pop    %rdi

SetPriorityClass:
	# stub
	retq

GetLogicalDrives:
	mov $0x4, %rax           # drive c: only
	retq

SetFilePointer:
	# maps 1:1 onto lseek
	push   %rdi
	push   %rsi
	push   %rdx

	mov    %rcx, %rdi
	mov    %rdx, %rsi
	mov    %r8, %rdx
	call   lseek

	pop    %rdx
	pop    %rsi
	pop    %rdi
	retq

FlushFileBuffers:
	# stub
	mov    $0x1, %rax
	retq
